
package de.ivu.elect.presentation.gruppe.table;

import static org.apache.commons.lang3.StringUtils.defaultIfBlank;
import static org.apache.commons.lang3.StringUtils.trimToEmpty;

import de.ivu.elect.business.ergebnis.entity.Ergebnisart;
import de.ivu.elect.business.gruppe.entity.KopfzahlKumulierteStimmen;
import de.ivu.elect.business.gruppe.entity.SystemGruppeEigenschaften;
import de.ivu.elect.jee.faces.Messages;
import de.ivu.elect.jee.presentation.dynamictable.ColumnType;

public class KopfzahlKumulierteStimmenAnteilErgebnisartFuerDifferenzColumn extends AbstractKopfzahlKumulierteStimmenColumn {

  private static final long serialVersionUID = 1L;

  private final Ergebnisart ergebnisartFuerDifferenz;

  public KopfzahlKumulierteStimmenAnteilErgebnisartFuerDifferenzColumn(Messages messages, SystemGruppeEigenschaften systemGruppeEigenschaften, Ergebnisart ergebnisartFuerDifferenz) {
    super(messages, systemGruppeEigenschaften);

    this.ergebnisartFuerDifferenz = ergebnisartFuerDifferenz;
  }

  @Override
  public ColumnType getType() {
    return AbstractGruppeKumulierteStimmenColumn.STIMMEN_ANTEIL_COLUMN_TYPE;
  }

  @Override
  public String getHeader() {
    return getMessage("gruppe.kumulierte.stimmen.anteil.ergebnisart.fuer.differenz", getMessage(ergebnisartFuerDifferenz));
  }

  @Override
  public Object getValue(KopfzahlKumulierteStimmen kopfzahlKumulierteStimmen) {
    if (isSystemGruppeWaehler(kopfzahlKumulierteStimmen.getGruppeImGebiet())) {
      return kopfzahlKumulierteStimmen.getAnteilVorperiode();
    }

    return null;
  }

  @Override
  public String getTooltip(KopfzahlKumulierteStimmen kopfzahlKumulierteStimmen) {
    return defaultIfBlank(super.getTooltip(kopfzahlKumulierteStimmen), kopfzahlKumulierteStimmen.getAnteilVorperiodeTooltip());
  }

  @Override
  public String getStyleClass() {
    return trimToEmpty(super.getStyleClass()) + " " + AbstractGruppeKumulierteStimmenColumn.ANTEIL_COLUMN_STYLE_CLASS + " " + AbstractGruppeKumulierteStimmenColumn.DIFFERENZ_COLUMN_STYLE_CLASS;
  }
}
